<?php
function authenticate_smtp($email, $password) {
    $smtp = fsockopen('ssl://smtp.gmail.com', 465, $errno, $errstr, 30);
    if (!$smtp) {
        throw new Exception("Failed to connect to SMTP server: $errstr ($errno)");
    }

    $commands = [
        "EHLO localhost",
        "AUTH LOGIN",
        base64_encode($email),
        base64_encode($password)
    ];

    $expected_responses = ['220', '250', '334', '334', '235'];

    for ($i = 0; $i < count($commands); $i++) {
        if ($i > 0) {
            fwrite($smtp, $commands[$i] . "\r\n");
        }
        $response = fgets($smtp);
        if (substr($response, 0, 3) !== $expected_responses[$i]) {
            throw new Exception("SMTP command failed: $response");
        }
    }

    return $smtp;
}